
package com.netsitech.caricese.paper.token;

import java.math.BigInteger;

/*
 BigInteger N = new BigInteger("<valore di N>");
 BigInteger D = new BigInteger("<valore di D>");
 BigInteger ris = encrypt(convert_to_number(stringa), D, N, "2");
 String token = ris.toString();			

 parametri:
 m: da decifrare
 e: chiave di cifratura (se si usa la chiave pubblica si deve decifrare con quella privata e viceversa)
 D: CHIAVE PRE DECIFRARE
 n: esponente

 */

public class RSA
{

	static BigInteger encrypt(BigInteger m, BigInteger e, BigInteger n, String mask)
	{
		BigInteger c = new BigInteger("0"); 
		BigInteger bitmask = (new BigInteger(mask)).pow(n.bitLength() - 1).subtract(new BigInteger("1"));
		BigInteger m2 = m;		
		int i = 0;		
		while (m2.compareTo(bitmask) == 1)
		{
			c = m2.and(bitmask).modPow(e, n).shiftLeft(i * n.bitLength()).or(c);
			m2 = m2.shiftRight(n.bitLength() - 1);
			i = i + 1;
		}
		c = m2.modPow(e, n).shiftLeft(i * n.bitLength()).or(c);
		return c;
	}

	static BigInteger decrypt(BigInteger c, BigInteger d, BigInteger n, String mask)
	{
		BigInteger m = new BigInteger("0");
		BigInteger c2 = c;
		int i = 0;
		for (BigInteger bitmask = (new BigInteger(mask)).pow(n.bitLength()).subtract(new BigInteger("1")); c2.compareTo(bitmask) == 1;)
		{
			m = c2.and(bitmask).modPow(d, n).shiftLeft(i * (n.bitLength() - 1)).or(m);
			c2 = c2.shiftRight(n.bitLength());
			i++;
		}
		m = c2.modPow(d, n).shiftLeft(i * (n.bitLength() - 1)).or(m);
		return m;
	}

}
